{$A+}

{ Basic framework to use DB functionality in an ISAPI DLL }

LIBRARY TemplateDB;

USES  Windows, SysUtils, IsapiVars, IsapiConn, DBTables, DB, BDE;


FUNCTION GetExtensionVersion (VAR VerInfo : TVerInfo) : BOOL; EXPORT; STDCALL;
BEGIN
  VerInfo.ExtensionVersion := MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR);
  StrPCopy( VerInfo.ExtensionDesc,'Template: Delphi ISAPI Extension');
  Result := TRUE;
END;

FUNCTION HttpExtensionProc(ECB : PECB) : CARDINAL; EXPORT; STDCALL;
VAR
  WebConn      : TIsapiConn;
  sesMyDB      : TSession;    { Session for this DLL }
  dbMyDB       : TDataBase;
  qryMyDB      : TQuery;      { Or TTable }

  { MakeSession creates a unique session id. Replace 'TemplateDB' with the name of your DLL }
  { Usualy Delphi creates automaticaly a session when you use DB functionality, but in this }
  { case you have to create it yourself (MakeSession does this) }

  FUNCTION MakeSession : TSession;
  VAR
    SessionName : STRING;
  BEGIN
    SessionName := 'TemplateDB' + IntToStr(GetCurrentThreadID);
    Result := Sessions.OpenSession(SessionName);
  END;

BEGIN
  WebConn := TIsapiConn.Create(ECB, 2048);
  IF WebConn.Status = stOK THEN
  BEGIN
    WebConn.Response.SendResponseHeader; { Allways at the begining }
    TRY
      sesMyDB := MakeSession;
      TRY
        dbMyDB := TDataBase.Create(NIL);
        TRY
          dbMyDB.SessionName := sesMyDB.SessionName;
          dbMyDB.LoginPrompt := FALSE; { MUST BE FALSE !!!!!!!!!!!!!!!!!! }
          dbMyDB.AliasName := 'myAliasName'; { Put here the Alias fot the database }
          dbMyDB.DataBaseName := 'dbMyDB'; { Any Name }
          dbMyDB.Open;
          {-}
          qryMyDB := TQuery.Create(NIL);  { Or TTable }
          TRY
            qryMyDB.SessionName := sesMyDB.SessionName;
            qryMyDB.DatabaseName := 'dbMyDB'; { Put here the same as in 'dbMyDB.DataBaseName' }

            { Put here the processing code }

          FINALLY
            qryMyDB.Close;
            qryMyDB.Free;
          END;
        FINALLY
          dbMyDB.Close;
          dbMyDB.Free;
        END;
      FINALLY
        sesMyDB.Close;
        sesMyDB.Free;
      END;
    EXCEPT
      ON e : EXCEPTION DO WebConn.SendError(e.Message);
    END;
    WebConn.Response.FlushBuffer; { Allways at the end }
  END;
  Result := HSE_STATUS_SUCCESS;
  WebConn.Free;
END;

EXPORTS
  HttpExtensionProc,
  GetExtensionVersion;
END.
