{$A+}

LIBRARY iEcho;

USES  Windows,
  SysUtils,
  IsapiVars,
  IsapiConn;

FUNCTION GetExtensionVersion (VAR VerInfo : TVerInfo) : BOOL; EXPORT; STDCALL;
BEGIN
  VerInfo.ExtensionVersion := MAKELONG(HSE_VERSION_MINOR,HSE_VERSION_MAJOR);
  StrPCopy( VerInfo.ExtensionDesc,'iEcho: Delphi 3.0 ISAPI Extension');
  Result := TRUE;
END;

FUNCTION HttpExtensionProc(ECB : PECB) : CARDINAL; EXPORT; STDCALL;
VAR
  WebConn      : TIsapiConn;

{--- Main begin ----------------------------------------------------}
BEGIN
  WebConn := TIsapiConn.Create(ECB, 2048);
  IF WebConn.Status = stOK THEN
  BEGIN
    IF WebConn.Request.QueryField['redir'] <> '' THEN BEGIN
      TRY
        WebConn.Response.SendURLRedirect(WebConn.Request.QueryField['redir']);
      EXCEPT
        ON e : EXCEPTION DO WebConn.SendError(e.Message);
      END;
    END ELSE
    BEGIN
      WebConn.Response.SendResponseHeader; { Allways at the begining }
      TRY
        WebConn.Response.HTMLBegin('WebServer Echo','','');

        WebConn.Response.Send('<FONT FACE="Arial" SIZE=3><B><U>iEcho ISAPI-Tool</U></B></FONT><BR>');

        WebConn.Response.Send('<FONT FACE="Arial" SIZE=2>');

        WebConn.Response.Send('<BR><B>AUTH_TYPE = </B>'+WebConn.Request.ServerVar[svAuthType]);
        WebConn.Response.Send('<BR><B>CONTENT_TYPE = </B>'+WebConn.Request.ServerVar[svContentType]);
        WebConn.Response.Send('<BR><B>PATH_INFO = </B>'+WebConn.Request.ServerVar[svPathInfo]);
        WebConn.Response.Send('<BR><B>PATH_TRANSLATED = </B>'+WebConn.Request.ServerVar[svPathTrans]);
        WebConn.Response.Send('<BR><B>QUERY_STRING = </B>'+WebConn.Request.ServerVar[svQueryString]);
        WebConn.Response.Send('<BR><B>REMOTE_ADDR = </B>'+WebConn.Request.ServerVar[svRemoteAddr]);
        WebConn.Response.Send('<BR><B>REMOTE_HOST = </B>'+WebConn.Request.ServerVar[svRemoteHost]);
        WebConn.Response.Send('<BR><B>REMOTE_USER = </B>'+WebConn.Request.ServerVar[svRemoteUser]);
        WebConn.Response.Send('<BR><B>UNMAPPED_REMOTE_USER = </B>'+WebConn.Request.ServerVar[svUnMappedUser]);
        WebConn.Response.Send('<BR><B>REQUEST_METHOD = </B>'+WebConn.Request.ServerVar[svReqMethod]);
        WebConn.Response.Send('<BR><B>SCRIPT_NAME = </B>'+WebConn.Request.ServerVar[svScriptName]);
        WebConn.Response.Send('<BR><B>SERVER_NAME = </B>'+WebConn.Request.ServerVar[svServerName]);
        WebConn.Response.Send('<BR><B>SERVER_PORT = </B>'+WebConn.Request.ServerVar[svServerPort]);
        WebConn.Response.Send('<BR><B>SERVER_PORT_SECURE = </B>'+WebConn.Request.ServerVar[svServerPortSec]);
        WebConn.Response.Send('<BR><B>SERVER_PROTOCOL = </B>'+WebConn.Request.ServerVar[svServerProtocol]);
        WebConn.Response.Send('<BR><B>SERVER_SOFTWARE = </B>'+WebConn.Request.ServerVar[svServerSoftware]);
        WebConn.Response.Send('<BR><B>HTTP_ACCEPT = </B>'+WebConn.Request.ServerVar[svHTTPAccept]);
        WebConn.Response.Send('<BR><B>HTTP_CONNECTION = </B>'+WebConn.Request.ServerVar[svHTTPConnection]);
        WebConn.Response.Send('<BR><B>HTTP_CONTENT_LENGTH = </B>'+WebConn.Request.ServerVar[svHTTPContentLen]);
        WebConn.Response.Send('<BR><B>HTTP_CONTENT_TYPE = </B>'+WebConn.Request.ServerVar[svHTTPContentType]);
        WebConn.Response.Send('<BR><B>HTTP_HOST = </B>'+WebConn.Request.ServerVar[svHTTPHost]);
        WebConn.Response.Send('<BR><B>HTTP_REFERER = </B>'+WebConn.Request.ServerVar[svHTTPReferer]);
        WebConn.Response.Send('<BR><B>HTTP_AUTHORIZATION = </B>'+WebConn.Request.ServerVar[svHTTPAuthorization]);
        WebConn.Response.Send('<BR><B>URL = </B>'+WebConn.Request.ServerVar[svURL]);

        WebConn.Response.Send('<BR><BR><BR></FONT>');
        IF WebConn.Request.Method = POST THEN BEGIN
          WebConn.Response.Send('POSTed data<BR><BR>');
          WebConn.Response.Send('Field = '+WebConn.Request.FormField['FIELD']+'<BR>');
          WebConn.Response.Send('Memo = ##'+WebConn.Request.FormField['MEMO']+'##<BR>');
          WebConn.Response.Send('<BR><BR>');
          WebConn.Response.Send('Field (URLDecode) = '+URLDecode(WebConn.Request.FormField['FIELD'])+'<BR>');
          WebConn.Response.Send('Memo (URLDecode) = ##'+URLDecode(WebConn.Request.FormField['MEMO'])+'##<BR>');
          WebConn.Response.Send('<BR><BR><BR>');
        END;
        WebConn.Response.Send('<FONT FACE="ARIAL" SIZE=2><B>Build with TIsapiConn (Delphi 3/4 ISAPI Extension Tool)</B></FONT><BR>');
        WebConn.Response.Send('<FONT FACE="Arial" SIZE=1><I>(c) 1999 <A HREF="mailto:imagrini@icore.ch">');
        WebConn.Response.Send('Ivan Magrini</A></I></FONT><BR><BR>');

        WebConn.Response.HTMLEnd;
      EXCEPT
        ON e : EXCEPTION DO WebConn.SendError(e.Message);
      END;
      WebConn.Response.FlushBuffer; { Allways at the end }
    END;
  END;
  Result := HSE_STATUS_SUCCESS;
  WebConn.Free;
END;

EXPORTS
  HttpExtensionProc,
  GetExtensionVersion;
END.
